<?php

// $Id: exif.class.php 137 2004-07-24 14:06:59Z tea $

/**
 * exif.class.php 
 *
 * @author TeaMiKL
 * @package PhpJPEG
 */

/**
 * include headers
 */
include_once "tiff.class.php";
include_once "exif.constants.php";

/**
 * Class for Exchangeable Image File Format.
 *
 * @author TeaMiKL
 * @package PhpJPEG
 * @todo make structure IFD0 IFD1 EXIF GPS ...
 */
class EXIF {

    /**
     * @var TIFF tiff
     */
    var $tiff;

    /**
     * @var string signature
     */
    var $signature;

    /**
     * @param String data
     * @todo Call by referrence to save memory.
     */
    function EXIF($data) {
        $this->tiff = NULL;
        $this->signature = "";
        $this->parse($data);
    }

    /**
     * @param String data
     * @todo refactoring API
     * @todo parse XML/RDF EXIF data.
     */
    function parse($data) {
        $signature = substr($data, 0, 4);
        
        if ($signature == "Exif") {
            $this->signature = $signature;
            $this->tiff = new TIFF(substr($data, 6, strlen($data)-6));
        }
        elseif ($signature == "http") {
            # TODO XML/RDF EXIF 
            $pos = strpos($data, "\x00", 0);
            $signature = substr($data, 0, $pos);

            # TODO URI literal
            if (ereg("^http://ns.adobi.com/xap/1.0", $signature)) {
                # $this->signature = $signature;

                # TODO Parse xpacket/RDF data
                # xpacket ... begin
                # RDF     ... 
                # xpacket ... end
                
                # echo "Position: $pos\n";
                # echo "Signature: $signature\n";
            }
        }
    }
}

?>
