<?php

// $Id: exif.constants.php 137 2004-07-24 14:06:59Z tea $

/**
 * Define EXIF and GPS Tag ID and information.
 *
 * @package PhpJPEG
 */

/**
 * EXIF TAG ID
 */
define ("EXIF_TAG_INTEROPERABILITY_INDEX",               0x0001);
define ("EXIF_TAG_INTEROPERABILITY_VERSION",             0x0002);
define ("EXIF_TAG_IMAGE_WIDTH",                          0x0100);
define ("EXIF_TAG_IMAGE_LENGTH",                         0x0101);
define ("EXIF_TAG_BITS_PER_SAMPLE",                      0x0102);
define ("EXIF_TAG_COMPRESSION",                          0x0103);
define ("EXIF_TAG_PHOTOMETRIC_INTERPRETATION",           0x0106);
define ("EXIF_TAG_FILL_ORDER",                           0x010a);
define ("EXIF_TAG_DOCUMENT_NAME",                        0x010d);
define ("EXIF_TAG_IMAGE_DESCRIPTION",                    0x010e);
define ("EXIF_TAG_MAKE",                                 0x010f);
define ("EXIF_TAG_MODEL",                                0x0110);
define ("EXIF_TAG_STRIP_OFFSETS",                        0x0111);
define ("EXIF_TAG_ORIENTATION",                          0x0112);
define ("EXIF_TAG_SAMPLES_PER_PIXEL",                    0x0115);
define ("EXIF_TAG_ROWS_PER_STRIP",                       0x0116);
define ("EXIF_TAG_STRIP_BYTE_COUNTS",                    0x0117);
define ("EXIF_TAG_X_RESOLUTION",                         0x011a);
define ("EXIF_TAG_Y_RESOLUTION",                         0x011b);
define ("EXIF_TAG_PLANAR_CONFIGURATION",                 0x011c);
define ("EXIF_TAG_RESOLUTION_UNIT",                      0x0128);
define ("EXIF_TAG_TRANSFER_FUNCTION",                    0x012d);
define ("EXIF_TAG_SOFTWARE",                             0x0131);
define ("EXIF_TAG_DATE_TIME",                            0x0132);
define ("EXIF_TAG_ARTIST",                               0x013b);
define ("EXIF_TAG_WHITE_POINT",                          0x013e);
define ("EXIF_TAG_PRIMARY_CHROMATICITIES",               0x013f);
define ("EXIF_TAG_TRANSFER_RANGE",                       0x0156);
define ("EXIF_TAG_JPEG_PROC",                            0x0200);
define ("EXIF_TAG_JPEG_INTERCHANGE_FORMAT",              0x0201);
define ("EXIF_TAG_JPEG_INTERCHANGE_FORMAT_LENGTH",       0x0202);
define ("EXIF_TAG_YCBCR_COEFFICIENTS",                   0x0211);
define ("EXIF_TAG_YCBCR_SUB_SAMPLING",                   0x0212);
define ("EXIF_TAG_YCBCR_POSITIONING",                    0x0213);
define ("EXIF_TAG_REFERENCE_BLACK_WHITE",                0x0214);
define ("EXIF_TAG_RELATED_IMAGE_FILE_FORMAT",            0x1000);
define ("EXIF_TAG_RELATED_IMAGE_WIDTH",                  0x1001);
define ("EXIF_TAG_RELATED_IMAGE_LENGTH",                 0x1002);
define ("EXIF_TAG_CFA_REPEAT_PATTERN_DIM",               0x828d);
define ("EXIF_TAG_CFA_PATTERN",                          0x828e);
define ("EXIF_TAG_BATTERY_LEVEL",                        0x828f);
define ("EXIF_TAG_COPYRIGHT",                            0x8298);
define ("EXIF_TAG_EXPOSURE_TIME",                        0x829a);
define ("EXIF_TAG_FNUMBER",                              0x829d);
define ("EXIF_TAG_IPTC_NAA",                             0x83bb);
define ("EXIF_TAG_EXIF_IFD_POINTER",                     0x8769);
define ("EXIF_TAG_INTER_COLOR_PROFILE",                  0x8773);
define ("EXIF_TAG_EXPOSURE_PROGRAM",                     0x8822);
define ("EXIF_TAG_SPECTRAL_SENSITIVITY",                 0x8824);
define ("EXIF_TAG_GPS_INFO_IFD_POINTER",                 0x8825);
define ("EXIF_TAG_ISO_SPEED_RATINGS",                    0x8827);
define ("EXIF_TAG_OECF",                                 0x8828);
define ("EXIF_TAG_EXIF_VERSION",                         0x9000);
define ("EXIF_TAG_DATE_TIME_ORIGINAL",                   0x9003);
define ("EXIF_TAG_DATE_TIME_DIGITIZED",                  0x9004);
define ("EXIF_TAG_COMPONENTS_CONFIGURATION",             0x9101);
define ("EXIF_TAG_COMPRESSED_BITS_PER_PIXEL",            0x9102);
define ("EXIF_TAG_SHUTTER_SPEED_VALUE",                  0x9201);
define ("EXIF_TAG_APERTURE_VALUE",                       0x9202);
define ("EXIF_TAG_BRIGHTNESS_VALUE",                     0x9203);
define ("EXIF_TAG_EXPOSURE_BIAS_VALUE",                  0x9204);
define ("EXIF_TAG_MAX_APERTURE_VALUE",                   0x9205);
define ("EXIF_TAG_SUBJECT_DISTANCE",                     0x9206);
define ("EXIF_TAG_METERING_MODE",                        0x9207);
define ("EXIF_TAG_LIGHT_SOURCE",                         0x9208);
define ("EXIF_TAG_FLASH",                                0x9209);
define ("EXIF_TAG_FOCAL_LENGTH",                         0x920a);
define ("EXIF_TAG_SUBJECT_AREA",                         0x9214);
define ("EXIF_TAG_MAKER_NOTE",                           0x927c);
define ("EXIF_TAG_USER_COMMENT",                         0x9286);
define ("EXIF_TAG_SUB_SEC_TIME",                         0x9290);
define ("EXIF_TAG_SUB_SEC_TIME_ORIGINAL",                0x9291);
define ("EXIF_TAG_SUB_SEC_TIME_DIGITIZED",               0x9292);
define ("EXIF_TAG_FLASH_PIX_VERSION",                    0xa000);
define ("EXIF_TAG_COLOR_SPACE",                          0xa001);
define ("EXIF_TAG_PIXEL_X_DIMENSION",                    0xa002);
define ("EXIF_TAG_PIXEL_Y_DIMENSION",                    0xa003);
define ("EXIF_TAG_RELATED_SOUND_FILE",                   0xa004);
define ("EXIF_TAG_INTEROPERABILITY_IFD_POINTER",         0xa005);
define ("EXIF_TAG_FLASH_ENERGY",                         0xa20b);
define ("EXIF_TAG_SPATIAL_FREQUENCY_RESPONSE",           0xa20c);
define ("EXIF_TAG_FOCAL_PLANE_X_RESOLUTION",             0xa20e);
define ("EXIF_TAG_FOCAL_PLANE_Y_RESOLUTION",             0xa20f);
define ("EXIF_TAG_FOCAL_PLANE_RESOLUTION_UNIT",          0xa210);
define ("EXIF_TAG_SUBJECT_LOCATION",                     0xa214);
define ("EXIF_TAG_EXPOSURE_INDEX",                       0xa215);
define ("EXIF_TAG_SENSING_METHOD",                       0xa217);
define ("EXIF_TAG_FILE_SOURCE",                          0xa300);
define ("EXIF_TAG_SCENE_TYPE",                           0xa301);
define ("EXIF_TAG_NEW_CFA_PATTERN",                      0xa302);
define ("EXIF_TAG_CUSTOM_RENDERED",                      0xa401);
define ("EXIF_TAG_EXPOSURE_MODE",                        0xa402);
define ("EXIF_TAG_WHITE_BALANCE",                        0xa403);
define ("EXIF_TAG_DIGITAL_ZOOM_RATIO",                   0xa404);
define ("EXIF_TAG_FOCAL_LENGTH_IN_35MM_FILM",            0xa405);
define ("EXIF_TAG_SCENE_CAPTURE_TYPE",                   0xa406);
define ("EXIF_TAG_GAIN_CONTROL",                         0xa407);
define ("EXIF_TAG_CONTRAST",                             0xa408);
define ("EXIF_TAG_SATURATION",                           0xa409);
define ("EXIF_TAG_SHARPNESS",                            0xa40a);
define ("EXIF_TAG_DEVICE_SETTING_DESCRIPTION",           0xa40b);
define ("EXIF_TAG_SUBJECT_DISTANCE_RANGE",               0xa40c);

/**
 * GPS TAG ID
 */
define ("GPS_TAG_VERSION_ID",                            0x0000);
define ("GPS_TAG_LATITUDE_REF",                          0x0001);
define ("GPS_TAG_LATITUDE",                              0x0002);
define ("GPS_TAG_LONGITUDE_REF",                         0x0003);
define ("GPS_TAG_LONGITUDE",                             0x0004);
define ("GPS_TAG_ALTITUDE_REF",                          0x0005);
define ("GPS_TAG_ALTITUDE",                              0x0006);
define ("GPS_TAG_TIME_STAMP",                            0x0007);
define ("GPS_TAG_SATELLITES",                            0x0008);
define ("GPS_TAG_STATUS",                                0x0009);
define ("GPS_TAG_MEASURE_MODE",                          0x000a);
define ("GPS_TAG_DOP",                                   0x000b);
define ("GPS_TAG_SPEED_REF",                             0x000c);
define ("GPS_TAG_SPEED",                                 0x000d);
define ("GPS_TAG_TRACK_REF",                             0x000e);
define ("GPS_TAG_TRACK",                                 0x000f);
define ("GPS_TAG_IMG_DIRECTION_REF",                     0x0010);
define ("GPS_TAG_IMG_DIRECTION",                         0x0011);
define ("GPS_TAG_MAP_DATUM",                             0x0012);
define ("GPS_TAG_DEST_LATITUDE_REF",                     0x0013);
define ("GPS_TAG_DEST_LATITUDE",                         0x0014);
define ("GPS_TAG_DEST_LONGITUDE_REF",                    0x0015);
define ("GPS_TAG_DEST_LONGITUDE",                        0x0016);
define ("GPS_TAG_DEST_BEARING_REF",                      0x0017);
define ("GPS_TAG_DEST_BEARING",                          0x0018);
define ("GPS_TAG_DEST_DISTANCE_REF",                     0x0019);
define ("GPS_TAG_DEST_DISTANCE",                         0x001a);
define ("GPS_TAG_PROCESSING_METHOD",                     0x001b);
define ("GPS_TAG_AREA_INFOMATION",                       0x001c);
define ("GPS_TAG_DATE_STAMP",                            0x001d);
define ("GPS_TAG_DIFFERENTIAL",                          0x001e);


$EXIF_INFO = array(
    EXIF_TAG_IMAGE_WIDTH                    => "ImageWidth",
    EXIF_TAG_IMAGE_LENGTH                   => "ImageLength",
    EXIF_TAG_BITS_PER_SAMPLE                => "BitPerSample",
    EXIF_TAG_COMPRESSION                    => "Compression",
    EXIF_TAG_PHOTOMETRIC_INTERPRETATION     => "PhotometricInterpretation",
    EXIF_TAG_FILL_ORDER                     => "FillOrder",
    EXIF_TAG_DOCUMENT_NAME                  => "DocumentName",
    EXIF_TAG_IMAGE_DESCRIPTION              => "ImageDescription",
    EXIF_TAG_MAKE                           => "Make",
    EXIF_TAG_MODEL                          => "Model",
    EXIF_TAG_STRIP_OFFSETS                  => "StripOffsets",
    EXIF_TAG_ORIENTATION                    => "Orientation",
    EXIF_TAG_SAMPLES_PER_PIXEL              => "SamplesPerPixel",
    EXIF_TAG_ROWS_PER_STRIP                 => "RowsPerStrip",
    EXIF_TAG_STRIP_BYTE_COUNTS              => "StripByteCounts",
    EXIF_TAG_X_RESOLUTION                   => "XResolution",
    EXIF_TAG_Y_RESOLUTION                   => "YResolution",
    EXIF_TAG_PLANAR_CONFIGURATION           => "PlanerConfiguration",
    EXIF_TAG_RESOLUTION_UNIT                => "ResolutionUnit",
    EXIF_TAG_TRANSFER_FUNCTION              => "TransferFunction",
    EXIF_TAG_SOFTWARE                       => "SoftWare",
    EXIF_TAG_DATE_TIME                      => "DateTime",
    EXIF_TAG_ARTIST                         => "Artist",
    EXIF_TAG_WHITE_POINT                    => "WhitePoint",
    EXIF_TAG_PRIMARY_CHROMATICITIES         => "PrimaryChromaticities",
    EXIF_TAG_TRANSFER_RANGE                 => "TransferRange",
    EXIF_TAG_JPEG_PROC                      => "JPEGProc",
    EXIF_TAG_JPEG_INTERCHANGE_FORMAT        => "JPEGInterchangeFormat",
    EXIF_TAG_JPEG_INTERCHANGE_FORMAT_LENGTH => "JPEGInterchangeFormatLength",
    EXIF_TAG_YCBCR_COEFFICIENTS             => "YCbCrCoefficients",
    EXIF_TAG_YCBCR_SUB_SAMPLING             => "YCbCrSubSampling",
    EXIF_TAG_YCBCR_POSITIONING              => "YCbCrPositioning",
    EXIF_TAG_REFERENCE_BLACK_WHITE          => "ReferenceBlackWhite",
    EXIF_TAG_CFA_REPEAT_PATTERN_DIM         => "CFARepeatPatternDim",
    EXIF_TAG_CFA_PATTERN                    => "CFAPattern",
    EXIF_TAG_BATTERY_LEVEL                  => "BatteryLevel",
    EXIF_TAG_COPYRIGHT                      => "Copyright",
    EXIF_TAG_EXPOSURE_TIME                  => "ExposureTime",
    EXIF_TAG_DATE_TIME_ORIGINAL             => "DateTimeOriginal",
    EXIF_TAG_DATE_TIME_DIGITIZED            => "DateTimeDigitized",
    EXIF_TAG_COMPONENTS_CONFIGURATION       => "ComponentsConfiguration",
    EXIF_TAG_COMPRESSED_BITS_PER_PIXEL      => "CompressedBitsPerPixel",
    EXIF_TAG_SHUTTER_SPEED_VALUE            => "ShutterSpeedValue",
    EXIF_TAG_APERTURE_VALUE                 => "ApertureValue",
    EXIF_TAG_BRIGHTNESS_VALUE               => "BrightnessValue",
    EXIF_TAG_EXPOSURE_BIAS_VALUE            => "ExposureBiasValue",
    EXIF_TAG_MAX_APERTURE_VALUE             => "MaxApertureValue",
    EXIF_TAG_SUBJECT_DISTANCE               => "SubjectDistance",
    EXIF_TAG_METERING_MODE                  => "MeteringMode",
    EXIF_TAG_LIGHT_SOURCE                   => "LightSource",
    EXIF_TAG_FLASH                          => "Flash",
    EXIF_TAG_FOCAL_LENGTH                   => "FocalLength",
    EXIF_TAG_MAKER_NOTE                     => "MakerNote",
    EXIF_TAG_USER_COMMENT                   => "UserComment",
    EXIF_TAG_SUB_SEC_TIME                   => "SubSecTime",
    EXIF_TAG_SUB_SEC_TIME_ORIGINAL          => "SubSecTimeOriginal",
    EXIF_TAG_SUB_SEC_TIME_DIGITIZED         => "SubSecTimeDigitized",
    EXIF_TAG_FLASH_PIX_VERSION              => "FlashPixVersion",
    EXIF_TAG_COLOR_SPACE                    => "ColorSpace",
    # XXX
    EXIF_TAG_PIXEL_X_DIMENSION              => "PixelXDimension",
    EXIF_TAG_PIXEL_Y_DIMENSION              => "PixelYDimension",
    EXIF_TAG_INTEROPERABILITY_INDEX         => "InteroperabilityIndex",
    EXIF_TAG_FLASH_ENERGY                   => "FlashEnergy",
    EXIF_TAG_SPATIAL_FREQUENCY_RESPONSE     => "SpatialFrequencyResponse",
    EXIF_TAG_FOCAL_PLANE_X_RESOLUTION       => "FocalPlaneXResolution",
    EXIF_TAG_FOCAL_PLANE_Y_RESOLUTION       => "FocalPlaneYResolution",
    EXIF_TAG_FOCAL_PLANE_RESOLUTION_UNIT    => "FocalPlaneResolutionUnit",
    EXIF_TAG_SUBJECT_LOCATION               => "SubjectLocation",
    EXIF_TAG_EXPOSURE_INDEX                 => "ExposureIndex",
    EXIF_TAG_SENSING_METHOD                 => "SensingMethod",
    EXIF_TAG_FILE_SOURCE                    => "FileSource",
    EXIF_TAG_SCENE_TYPE                     => "SceneType",

    EXIF_TAG_EXIF_IFD_POINTER               => "ExifIFDPointer",
    EXIF_TAG_FNUMBER                        => "FNumber",
    EXIF_TAG_EXPOSURE_PROGRAM               => "ExposureProgram",
    EXIF_TAG_ISO_SPEED_RATINGS              => "ISOSpeedRatings",
    EXIF_TAG_EXIF_VERSION                   => "ExifVersion",
    EXIF_TAG_NEW_CFA_PATTERN                => "NewCFAPattern",
    EXIF_TAG_CUSTOM_RENDERED                => "CustomRendered",
    EXIF_TAG_EXPOSURE_MODE                  => "ExposureMode",
    EXIF_TAG_WHITE_BALANCE                  => "WhiteBlance",
    EXIF_TAG_DIGITAL_ZOOM_RATIO             => "DigitalZoomRatio",
    EXIF_TAG_FOCAL_LENGTH_IN_35MM_FILM      => "FocalLengthIn35MMFilm",
    EXIF_TAG_SCENE_CAPTURE_TYPE             => "SceneCaptureType",
    EXIF_TAG_GAIN_CONTROL                   => "GainControl",
    EXIF_TAG_CONTRAST                       => "Contrast",
    EXIF_TAG_SATURATION                     => "Saturation",
    EXIF_TAG_SHARPNESS                      => "Sharpness",
    EXIF_TAG_DEVICE_SETTING_DESCRIPTION     => "DeviceSettingDescription",
    EXIF_TAG_SUBJECT_DISTANCE_RANGE         => "SubjectDistanceRange",

    EXIF_TAG_GPS_INFO_IFD_POINTER           => "GPSInfoIFDPointer",
);

$GPS_INFO = array(
    GPS_TAG_VERSION_ID                      => "GPS Version",
    GPS_TAG_LATITUDE_REF                    => "North or South Latitude",
    GPS_TAG_LATITUDE                        => "Latitude",
    GPS_TAG_LONGITUDE_REF                   => "Eastor West Longitude",
    GPS_TAG_LONGITUDE                       => "Longitude",
    GPS_TAG_ALTITUDE_REF                    => "Altitude Reference",
    GPS_TAG_ALTITUDE                        => "Altitude",
    GPS_TAG_TIME_STAMP                      => "GPS Time",
    # XXX about satellites value
    GPS_TAG_SATELLITES                      => "GPS Satellites",
    GPS_TAG_STATUS                          => "GPS Receiver Status",
    GPS_TAG_MEASURE_MODE                    => "GPS Measurement Mode",
    GPS_TAG_DOP                             => "Measurement Precision",
    GPS_TAG_SPEED_REF                       => "Speed Unit",
    GPS_TAG_SPEED                           => "Speed of GPS Receiver",
    GPS_TAG_TRACK_REF           => "Reference for direction of movement",
    GPS_TAG_TRACK               => "Direction of movement",
    GPS_TAG_IMG_DIRECTION_REF   => "Reference for direction of image",
    GPS_TAG_IMG_DIRECTION       => "Direction of image",
    GPS_TAG_MAP_DATUM           => "Geo detic survey data used",
    GPS_TAG_DEST_LATITUDE_REF   => "Reference for latitude of destination",
    GPS_TAG_DEST_LATITUDE       => "Latitude of destination",
    GPS_TAG_DEST_LONGITUDE_REF  => "Reference for longitude of destination",
    GPS_TAG_DEST_LONGITUDE      => "Longitude of destination",
    GPS_TAG_DEST_BEARING_REF    => "Reference for bearing of destination",
    GPS_TAG_DEST_BEARING        => "Bearing of destination",
    GPS_TAG_DEST_DISTANCE_REF   => "Reference for distance to destination",
    GPS_TAG_DEST_DISTANCE       => "Distance to destination",
    GPS_TAG_PROCESSING_METHOD   => "Name of GPS processing method",
    GPS_TAG_AREA_INFOMATION     => "Name of GPS area",
    GPS_TAG_DATE_STAMP          => "GPS data",
    GPS_TAG_DIFFERENTIAL        => "GPS Differential correction",
);

?>
