<?php

// $Id: jpeg.constants.php 137 2004-07-24 14:06:59Z tea $

/**
 * Define constants, Marker literal and descriptions.
 *
 * @package PhpJPEG
 */

# NOTES: 0xc4 0xc8 0xcc are not part of SOF.

/**
 * JPEG Marker 
 */
define ("M_DHT",   0xc4);
define ("M_JPG",   0xc8);
define ("M_DAC",   0xcc);

define ("M_SOF0",  0xc0);
define ("M_SOF1",  0xc1);
define ("M_SOF2",  0xc2);
define ("M_SOF3",  0xc3);
define ("M_SOF5",  0xc5);
define ("M_SOF6",  0xc6);
define ("M_SOF7",  0xc7);
define ("M_SOF9",  0xc9);
define ("M_SOF10", 0xca);
define ("M_SOF11", 0xcb);
define ("M_SOF13", 0xcd);
define ("M_SOF14", 0xce);
define ("M_SOF15", 0xcf);

define ("M_RST0",  0xd0);
define ("M_RST1",  0xd1);
define ("M_RST2",  0xd2);
define ("M_RST3",  0xd3);
define ("M_RST4",  0xd4);
define ("M_RST5",  0xd5);
define ("M_RST6",  0xd6);
define ("M_RST7",  0xd7);
define ("M_SOI",   0xd8);
define ("M_EOI",   0xd9);
define ("M_SOS",   0xda);
define ("M_DQT",   0xdb);
define ("M_DNL",   0xdc);
define ("M_DRI",   0xdd);
define ("M_DHP",   0xde);
define ("M_EXP",   0xdf);

define ("M_APP0",  0xe0);
define ("M_APP1",  0xe1);
define ("M_APP2",  0xe2);
define ("M_APP3",  0xe3);
define ("M_APP4",  0xe4);
define ("M_APP5",  0xe5);
define ("M_APP6",  0xe6);
define ("M_APP7",  0xe7);
define ("M_APP8",  0xe8);
define ("M_APP9",  0xe9);
define ("M_APP10", 0xea);
define ("M_APP11", 0xeb);
define ("M_APP12", 0xec);
define ("M_APP13", 0xed);
define ("M_APP14", 0xee);
define ("M_APP15", 0xef);

define ("M_JPG0",  0xf0);
define ("M_JPG1",  0xf1);
define ("M_JPG2",  0xf2);
define ("M_JPG3",  0xf3);
define ("M_JPG4",  0xf4);
define ("M_JPG5",  0xf5);
define ("M_JPG6",  0xf6);
define ("M_JPG7",  0xf7);
define ("M_JPG8",  0xf8);
define ("M_JPG9",  0xf9);
define ("M_JPG10", 0xfa);
define ("M_JPG11", 0xfb);
define ("M_JPG12", 0xfc);
define ("M_JPG13", 0xfd);
define ("M_COM",   0xfe);


$SOF_descriptions = array(
    M_SOF0  => "Baseline",
    
    M_SOF1  => "Extended sequential, Haffman",
    M_SOF2  => "Progressive Haffman",
    M_SOF3  => "Lossless Haffman",
    
    M_SOF5  => "Differential sequential, Haffman",
    M_SOF6  => "Differential progressive, Haffman",
    M_SOF7  => "Differential lossless, Haffman",
    
    M_SOF9  => "Extended sequential, arithmetic",
    M_SOF10 => "Progressive arithmetic",
    M_SOF11 => "Lossless arithmetic",
    
    M_SOF13 => "Differential sequential, arithmetic",
    M_SOF14 => "Differential progressive, arithmetic",
    M_SOF15 => "Differential lossless, arithmetic",
);

$APP_desctiptions = array(
    M_APP0 => "",
    M_APP1 => "",
    M_APP2 => "",
    M_APP3 => "",
    M_APP4 => "",
    M_APP5 => "",
    M_APP6 => "",
    M_APP7 => "",
    M_APP8 => "",
    M_APP9 => "",
    M_APP10 => "",
    M_APP11 => "",
    M_APP12 => "",
    M_APP13 => "",
    M_APP14 => "",
    M_APP15 => "",
);

$SOF_array = array_keys($SOF_descriptions);
$APP_array = array_keys($APP_desctiptions);


?>

